#include <amxmodx>
#include <engine>
#include <fakemeta>
#include <reapi>

#define PLUGIN "CS Revo: SemiClip Lite"
#define VERSION "1.0"
#define AUTHOR "Wilian M."

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)

	RegisterHookChain(RG_CBasePlayer_PreThink, "on_player_prethink_post", true)
	RegisterHookChain(RG_CBasePlayer_PostThink, "on_player_posthink_post", true)
	register_forward(FM_AddToFullPack, "add_to_full_pack_post", true)
}

public on_player_prethink_post(const this)
{
	set_solid(this, SOLID_NOT)
}

public on_player_posthink_post(const this)
{
	set_solid(this, SOLID_SLIDEBOX)
}

public add_to_full_pack_post(es, e, ent, host, hostflags, player, pset)
{
	if(!player || host == ent || !is_user_alive(host) || !is_user_alive(ent) || get_member(host, m_iTeam) != get_member(ent, m_iTeam) || !get_orig_retval())
		return

	set_es(es, ES_Solid, SOLID_NOT)

	static Float:dist
	dist = entity_range(host, ent)

	if(dist < 150.0)
	{
		set_es(es, ES_RenderMode, kRenderTransAlpha)
		set_es(es, ES_RenderAmt, floatround(dist / 1.5))
	}
}

set_solid(const this, solid_type)
{
	if(!is_user_alive(this) || !(get_member(this, m_iTeam) >= TEAM_TERRORIST || get_member(this, m_iTeam) <= TEAM_CT))
		return

	static players[32], num, player, i
	get_players(players, num, "ae", (get_member(this, m_iTeam) == TEAM_TERRORIST) ? "TERRORIST" : "CT")

	for(i = 0; i < num; i++)
	{
		player = players[i]

		if(this != player)
			set_entvar(player, var_solid, solid_type)
	}
}